---
title: Simple Usage
order: 1
---

本 Demo 演示 DragTable 的用法。

```jsx
import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import DragTable from 'shj-drag-table';

class App extends Component {
  constructor (props) {
    super(props)
    
    this.state = {
      columns: [
        {
          title: '姓名',
          key: 'name',
          dataIndex: 'name',
          width: 160,
          fixed: 'left',
          render: (text, record) => <a className="link" onClick={() => console.log(record)}>{text}</a>
        },
        {
          title: '年龄',
          key: 'age',
          dataIndex: 'age',
          width: 200,
          hidden: true,
        },
        {
            title: '客户名称',
            dataIndex: 'customerName',
            width: 130,
            // search: false,
        },
        {
            title: '联系电话',
            dataIndex: 'phone',
            key: 'phone',
            width: 130,
            search: false,
        },
        {
            title: '楼盘名称',
            dataIndex: 'buildingName',
            key: 'buildingName',
            width: 160,
            search: false,
        },
        {
          title: '公司',
          key: 'companyName',
          dataIndex: 'companyName',
          width: 100,
          fixed: 'left'
        },
        {
          title: '房号',
          key: 'roomNo',
          dataIndex: 'roomNo',
          width: 100,
          // fixed: 'left'
        },
        {
          title: '来源',
          dataIndex: 'source',
          key: 'source',
          width: 180,
        },
        {
          title: '户型',
          dataIndex: 'roomType',
          key: 'roomType',
          width: 80,
          // search: false,
      },
      {
          title: '风格',
          dataIndex: 'styleName',
          key: 'styleName',
          width: 80,
          // search: false,
      },
        {
          title: '建筑面积',
          dataIndex: 'buildingArea',
          key: 'buildingArea',
          width: 80,
          // search: false,
        },
        {
            title: '套内面积（㎡）',
            dataIndex: 'innerArea',
            key: 'innerArea',
            width: 120,
            // search: false,
        },
        {
          title: '品牌',
          key: 'brandName',
          dataIndex: 'brandName',
          width: 300
        },
        {
          title: '房屋属性',
          key: 'roomAttrName',
          dataIndex: 'roomAttrName',
          width: 200,
          // fixed: 'right'
        },
        {
          title: '房屋类型',
          key: 'roomCateName',
          dataIndex: 'roomCateName',
          width: 300,
        },
        {
            title: '交房日期',
            dataIndex: 'deliverDate',
            key: 'deliverDate',
            width: 80,
            // search: false,
        },
        {
            title: '状态',
            dataIndex: 'decorStatusName',
            key: 'decorStatusName',
            width: 80,
            // search: false,
        },
        {
            title: '跟进人',
            dataIndex: 'currentWorkerName',
            key: 'currentWorkerName',
            width: 80,
            // search: false,
        },
        {
            title: '更新时间',
            dataIndex: 'lastUpdatedTime',
            width: 220,
            search: false,
        },
        {
            title: '创建时间',
            dataIndex: 'createdTime',
            key: 'createdTime',
            width: 220
        },
        {
            title: '创建时间2',
            dataIndex: 'createdTime',
            key: 'createdTime',
            width: 220
        },
        {
            title: '更新人',
            dataIndex: 'modifiedByName',
            key: 'modifiedByName',
            width: 220
        },
        {
          title: '操作',
          key: 'action',
          dataIndex: 'action',
          width: 100,
          fixed: 'right'
        }
      ],
      columnsState: {
        buildingName: { show: false },
        companyName: { show: false },
        roomNo: { show: false },
        source: { show: false },
        roomType: { show: false },
        styleName: { show: false },
        buildingArea: { show: false },
      },
      data: [],
      loading: true,
      total: 0,
      selectedRows: []
    }
  }

  componentDidMount () {
    let data = []
    let total = 120;
    for (let i = 0; i < total; i++) {
      data.push({
        id: i + 1,
        name: 'Jasmine_' + i,
        age: 18,
        companyName: '产品_' + i,
        roomNo: 'roomNo_' + i,
        brandName: 'brandName_' + i,
        roomAttrName: 'roomAttrName_' + i,
        roomCateName: 'roomCateName_' + i,
        styleName: 'styleName_' + i,
        source: 'source_' + i,
        roomType: 'roomType_' + i,
        buildingArea: 'buildingArea_' + i,
        innerArea: 'innerArea_' + i,
        deliverDate: 'deliverDate_' + i,
        decorStatusName: 'decorStatusName_' + i,
        currentWorkerName: 'currentWorkerName_' + i,
        lastUpdatedTime: 'lastUpdatedTime_' + i,
        createdTime: 'createdTime_' + i,
        modifiedByName: 'modifiedByName_' + i,
        customerName: 'customerName_' + i,
        phone: 'phone_' + i,
        buildingName: 'buildingName_' + i,
        desc: '这是展开的描述啊_' + i
      })
    }
    setTimeout(() => { this.setState({ data, loading: false, total }) }, 1000)
  }

  onSetting () {
    this.table.openSetting()
  }

  onReload () {
    this.setState({selectedRows: []})
  }

  render() {
    return <div>
      <button onClick={this.onSetting.bind(this)}>设置</button>
      &nbsp;&nbsp;&nbsp;
      <button onClick={this.onReload.bind(this)}>重载</button>
      <DragTable 
        // cacheDisabled
        ref={ref => this.table = ref}
        columns={this.state.columns} 
        columnsState={this.state.columnsState}
        data={this.state.data} 
        total={this.state.total} 
        loading={this.state.loading}
        // cacheKey="test1"
        sticky
        // rowSelection={{
        //   selectedRowKeys: this.state.selectedRows,
        //   onChange: (selectedRows) => {
        //       this.setState({ selectedRows })
        //   }
        // }} 
        rowSelection={null}
      />

    </div>
  }
}

ReactDOM.render((
  <App />
), mountNode);
```
