import React, { useRef, useState, useEffect, forwardRef, useImperativeHandle } from 'react';
var Checkbox = /*#__PURE__*/forwardRef(function (props, ref) {
  var checked = props.checked,
      onChange = props.onChange;
  useImperativeHandle(ref, function () {
    return {
      setIndeterminate: function setIndeterminate(val) {
        _setIndeterminate(val);
      }
    };
  });
  var inputRef = useRef();

  var _useState = useState(false),
      indeterminate = _useState[0],
      _setIndeterminate = _useState[1];

  useEffect(function () {
    inputRef.current.indeterminate = indeterminate;
    return function () {};
  }, [indeterminate]);
  useEffect(function () {
    if (checked) {
      _setIndeterminate(!checked);
    }

    return function () {};
  }, [checked]);

  var _onChange = function _onChange(ev) {
    var checked = ev.target.checked;
    onChange && onChange(checked);
  };

  return /*#__PURE__*/React.createElement("label", {
    className: "shj-checkbox-wrap"
  }, /*#__PURE__*/React.createElement("span", {
    className: "shj-checkbox " + (checked ? 'shj-checkbox-checked' : '') + " " + (indeterminate ? 'shj-checkbox-indeterminate' : '')
  }, /*#__PURE__*/React.createElement("input", {
    ref: inputRef,
    checked: checked,
    type: "checkbox",
    className: "shj-checkbox-input",
    onChange: _onChange
  }), /*#__PURE__*/React.createElement("span", {
    className: "shj-checkbox-inner"
  })), /*#__PURE__*/React.createElement("span", null, props.children));
});
export default Checkbox;