"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var Checkbox = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var checked = props.checked,
      onChange = props.onChange;
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      setIndeterminate: function setIndeterminate(val) {
        _setIndeterminate(val);
      }
    };
  });
  var inputRef = (0, _react.useRef)();

  var _useState = (0, _react.useState)(false),
      indeterminate = _useState[0],
      _setIndeterminate = _useState[1];

  (0, _react.useEffect)(function () {
    inputRef.current.indeterminate = indeterminate;
    return function () {};
  }, [indeterminate]);
  (0, _react.useEffect)(function () {
    if (checked) {
      _setIndeterminate(!checked);
    }

    return function () {};
  }, [checked]);

  var _onChange = function _onChange(ev) {
    var checked = ev.target.checked;
    onChange && onChange(checked);
  };

  return /*#__PURE__*/_react["default"].createElement("label", {
    className: "shj-checkbox-wrap"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "shj-checkbox " + (checked ? 'shj-checkbox-checked' : '') + " " + (indeterminate ? 'shj-checkbox-indeterminate' : '')
  }, /*#__PURE__*/_react["default"].createElement("input", {
    ref: inputRef,
    checked: checked,
    type: "checkbox",
    className: "shj-checkbox-input",
    onChange: _onChange
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: "shj-checkbox-inner"
  })), /*#__PURE__*/_react["default"].createElement("span", null, props.children));
});
var _default = Checkbox;
exports["default"] = _default;