"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = exports.insertOfIndex = void 0;

var _col = _interopRequireDefault(require("antd/lib/col"));

var _tooltip = _interopRequireDefault(require("antd/lib/tooltip"));

var _row = _interopRequireDefault(require("antd/lib/row"));

var _space = _interopRequireDefault(require("antd/lib/space"));

var _button = _interopRequireDefault(require("antd/lib/button"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _reactDnd = require("react-dnd");

var _reactDndHtml5Backend = require("react-dnd-html5-backend");

var _shjCrmDialog = _interopRequireDefault(require("shj-crm-dialog"));

var _Icon = require("./Icon");

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } it = o[Symbol.iterator](); return it.next.bind(it); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var SettingModal = function SettingModal(config) {
  var left = config.left,
      right = config.right,
      notFixed = config.notFixed,
      hiddenColumns = config.hiddenColumns,
      defaultColumns = config.defaultColumns;
  var dialog = (0, _shjCrmDialog["default"])((0, _extends2["default"])({
    title: '设置',
    content: /*#__PURE__*/_react["default"].createElement(_reactDnd.DndProvider, {
      backend: _reactDndHtml5Backend.HTML5Backend
    }, /*#__PURE__*/_react["default"].createElement(TableSetting, {
      data: {
        left: left,
        right: right,
        notFixed: notFixed,
        hiddenColumns: hiddenColumns,
        defaultColumns: defaultColumns
      },
      onClose: function onClose() {
        return dialog.destroy();
      },
      onSubmit: config.onSubmit
    }))
  }, config));
  return dialog;
}; // 根据索引插入元素


var insertOfIndex = function insertOfIndex(arr, el) {
  var nextArr = [].concat(arr);
  var i = 0;
  var isAdd = false;

  for (var _iterator = _createForOfIteratorHelperLoose(arr), _step; !(_step = _iterator()).done;) {
    var d = _step.value;

    if (d.index > el.index) {
      var _index = nextArr.findIndex(function (item) {
        return item.ukey === el.ukey;
      });

      if (_index === -1) {
        nextArr.splice(i, 0, el);
      } else {
        nextArr[_index] = el;
      }

      isAdd = true;
      break;
    }

    i++;
  }

  if (!isAdd) {
    var index = nextArr.findIndex(function (item) {
      return item.ukey === el.ukey;
    });

    if (index === -1) {
      nextArr.push(el);
    } else {
      nextArr[index] = el;
    }
  }

  return nextArr;
};

exports.insertOfIndex = insertOfIndex;

var TableSetting = function TableSetting(props) {
  var data = props.data,
      onSubmit = props.onSubmit;

  var _useState = (0, _react.useState)([]),
      _left = _useState[0],
      setLeft = _useState[1];

  var _useState2 = (0, _react.useState)([]),
      _right = _useState2[0],
      setRight = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _notFixed = _useState3[0],
      setNotFixed = _useState3[1];

  (0, _react.useEffect)(function () {
    var filterFunc = function filterFunc(d) {
      return d.type !== 'selection';
    };

    var left = data.left.filter(filterFunc);
    var right = data.right.filter(filterFunc);
    var notFixed = data.notFixed.filter(filterFunc);

    for (var _iterator2 = _createForOfIteratorHelperLoose(data.hiddenColumns), _step2; !(_step2 = _iterator2()).done;) {
      var d = _step2.value;

      if (d.fixed === 'left') {
        left = insertOfIndex(left, d);
      } else if (d.fixed === 'right') {
        right = insertOfIndex(right, d);
      } else {
        notFixed = insertOfIndex(notFixed, d);
      }
    } // console.log(data.hiddenColumns, notFixed)


    setLeft(left);
    setRight(right);
    setNotFixed(notFixed);
    return function () {};
  }, [data]);
  var moveCard = (0, _react.useCallback)(function (dragIndex, hoverIndex, itemType) {
    var func = {
      left: function left() {
        return setLeft(moveArr(_left, dragIndex, hoverIndex));
      },
      right: function right() {
        return setRight(moveArr(_right, dragIndex, hoverIndex));
      },
      notFixed: function notFixed() {
        return setNotFixed(moveArr(_notFixed, dragIndex, hoverIndex));
      }
    }[itemType];
    func && func();
  }, [_left, _right, _notFixed]);

  var moveArr = function moveArr(arr, dragIndex, hoverIndex) {
    var nextArr = [].concat(arr);
    var dragCard = nextArr[dragIndex];
    var tempIndex = dragCard.index;
    dragCard.index = nextArr[hoverIndex].index;
    nextArr[hoverIndex].index = tempIndex;
    nextArr.splice(dragIndex, 1);
    nextArr.splice(hoverIndex, 0, dragCard);
    return nextArr;
  };

  var setVisible = (0, _react.useCallback)(function (index, checked, itemType, data) {
    var func = {
      left: function left() {
        return setLeft(setItemVisible(_left, index, checked));
      },
      right: function right() {
        return setRight(setItemVisible(_right, index, checked));
      },
      notFixed: function notFixed() {
        return setNotFixed(setItemVisible(_notFixed, index, checked));
      }
    }[itemType];
    func && func();
  }, [_left, _right, _notFixed]);

  var setItemVisible = function setItemVisible(arr, index, checked) {
    var nextArr = [].concat(arr);
    nextArr[index] = (0, _extends2["default"])({}, nextArr[index], {
      hidden: !checked
    });
    return nextArr;
  };

  var setFixed = (0, _react.useCallback)(function (index, fixedValue, itemType, data) {
    var func = {
      left: function left() {
        return moveFixedItem(_left, index, fixedValue);
      },
      right: function right() {
        return moveFixedItem(_right, index, fixedValue);
      },
      notFixed: function notFixed() {
        return moveFixedItem(_notFixed, index, fixedValue);
      }
    }[itemType];
    func && func();
  }, [_left, _right, _notFixed]);

  var moveFixedItem = function moveFixedItem(arr, index, fixedValue) {
    var el = (0, _extends2["default"])({}, arr[index]);
    arr.splice(index, 1);
    el.fixed = fixedValue;
    var func = {
      left: function left() {
        return setLeft(insertOfIndex(_left, el));
      },
      right: function right() {
        return setRight(insertOfIndex(_right, el));
      },
      notFixed: function notFixed() {
        return setNotFixed(insertOfIndex(_notFixed, el));
      }
    }[fixedValue || 'notFixed'];
    func && func();
  };

  var onCancel = function onCancel() {
    props.onClose && props.onClose();
  };

  var onReset = function onReset() {
    onSubmit && onSubmit([].concat(data.defaultColumns));
  };

  var onOk = function onOk() {
    onSubmit && onSubmit([].concat(_left, _notFixed, _right));
  };

  var hasSubTitle = _left.length || _right.length;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-table-col-setting " + (hasSubTitle ? 'has-sub-title' : '')
  }, !_left.length ? null : /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-table-setting-box"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-setting-sub-title"
  }, "\u56FA\u5B9A\u5728\u5DE6\u4FA7"), _left.map(function (d, i) {
    return /*#__PURE__*/_react["default"].createElement(Card, {
      key: d.ukey,
      id: d.ukey,
      index: i,
      data: d,
      itemType: "left",
      moveCard: moveCard,
      setVisible: setVisible,
      setFixed: setFixed
    });
  })), !_notFixed.length ? null : /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-table-setting-box"
  }, !hasSubTitle ? null : /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-setting-sub-title"
  }, "\u4E0D\u56FA\u5B9A"), _notFixed.map(function (d, i) {
    return /*#__PURE__*/_react["default"].createElement(Card, {
      key: d.ukey,
      id: d.ukey,
      index: i,
      data: d,
      itemType: "notFixed",
      moveCard: moveCard,
      setVisible: setVisible,
      setFixed: setFixed
    });
  })), !_right.length ? null : /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-table-setting-box"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-setting-sub-title"
  }, "\u56FA\u5B9A\u5728\u53F3\u4FA7"), _right.map(function (d, i) {
    return /*#__PURE__*/_react["default"].createElement(Card, {
      key: d.ukey,
      id: d.ukey,
      index: i,
      data: d,
      itemType: "right",
      moveCard: moveCard,
      setVisible: setVisible,
      setFixed: setFixed
    });
  })), /*#__PURE__*/_react["default"].createElement(_row["default"], {
    justify: "end",
    style: {
      marginTop: '20px'
    }
  }, /*#__PURE__*/_react["default"].createElement(_space["default"], null, /*#__PURE__*/_react["default"].createElement(_button["default"], {
    onClick: onCancel
  }, "\u53D6\u6D88"), /*#__PURE__*/_react["default"].createElement(_button["default"], {
    danger: true,
    onClick: onReset
  }, "\u91CD\u7F6E"), /*#__PURE__*/_react["default"].createElement(_button["default"], {
    type: "primary",
    onClick: onOk
  }, "\u786E\u5B9A"))));
};

var Card = function Card(props) {
  var ref = (0, _react.useRef)(null);
  var data = props.data,
      id = props.id,
      index = props.index,
      itemType = props.itemType,
      moveCard = props.moveCard,
      setVisible = props.setVisible,
      setFixed = props.setFixed;

  var onChange = function onChange(ev) {
    var checked = ev.target.checked;
    setVisible && setVisible(index, checked, itemType, data);
  };

  var onFixedLeft = function onFixedLeft() {
    setFixed && setFixed(index, 'left', itemType, data);
  };

  var onFixedRight = function onFixedRight() {
    setFixed && setFixed(index, 'right', itemType, data);
  };

  var onCancelFixed = function onCancelFixed() {
    setFixed && setFixed(index, '', itemType, data);
  };

  var _useDrop = (0, _reactDnd.useDrop)({
    accept: itemType,
    hover: function hover(item, monitor) {
      var _ref$current;

      if (!ref.current) {
        return;
      }

      var dragIndex = item.index;
      var hoverIndex = index; // Don't replace items with themselves

      if (dragIndex === hoverIndex) {
        return;
      } // Determine rectangle on screen


      var hoverBoundingRect = (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.getBoundingClientRect(); // Get vertical middle

      var hoverMiddleY = (hoverBoundingRect.bottom - hoverBoundingRect.top) / 2; // Determine mouse position

      var clientOffset = monitor.getClientOffset(); // Get pixels to the top

      var hoverClientY = clientOffset.y - hoverBoundingRect.top; // Only perform the move when the mouse has crossed half of the items height
      // When dragging downwards, only move when the cursor is below 50%
      // When dragging upwards, only move when the cursor is above 50%
      // Dragging downwards

      if (dragIndex < hoverIndex && hoverClientY < hoverMiddleY) {
        return;
      } // Dragging upwards


      if (dragIndex > hoverIndex && hoverClientY > hoverMiddleY) {
        return;
      } // Time to actually perform the action


      moveCard(dragIndex, hoverIndex, itemType); // Note: we're mutating the monitor item here!
      // Generally it's better to avoid mutations,
      // but it's good here for the sake of performance
      // to avoid expensive index searches.

      item.index = hoverIndex;
    }
  }),
      drop = _useDrop[1];

  var _useDrag = (0, _reactDnd.useDrag)({
    item: {
      type: itemType,
      id: id,
      index: index
    },
    collect: function collect(monitor) {
      return {
        isDragging: monitor.isDragging()
      };
    }
  }),
      isDragging = _useDrag[0].isDragging,
      drag = _useDrag[1];

  var opacity = isDragging ? 0 : 1;
  drag(drop(ref));

  var notAlign = function notAlign() {
    return /*#__PURE__*/_react["default"].createElement(_tooltip["default"], {
      placement: "top",
      title: '不固定'
    }, /*#__PURE__*/_react["default"].createElement("i", {
      onClick: onCancelFixed
    }, /*#__PURE__*/_react["default"].createElement(_Icon.VerticalAlignMiddle, null)));
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: 'shj-table-setting-card',
    ref: ref,
    style: {
      opacity: opacity
    }
  }, /*#__PURE__*/_react["default"].createElement(_row["default"], null, /*#__PURE__*/_react["default"].createElement(_col["default"], {
    className: 'setting-col center',
    span: 3
  }, /*#__PURE__*/_react["default"].createElement("input", {
    type: "checkbox",
    checked: !data.hidden,
    onChange: onChange
  })), /*#__PURE__*/_react["default"].createElement(_col["default"], {
    className: 'setting-col',
    span: 15
  }, data.title), /*#__PURE__*/_react["default"].createElement(_col["default"], {
    className: 'setting-col center',
    span: 6
  }, !data.width ? null : /*#__PURE__*/_react["default"].createElement(_space["default"], {
    size: "large"
  }, itemType === 'left' ? notAlign() : /*#__PURE__*/_react["default"].createElement(_tooltip["default"], {
    placement: "top",
    title: '固定在列首'
  }, /*#__PURE__*/_react["default"].createElement("i", {
    onClick: onFixedLeft
  }, /*#__PURE__*/_react["default"].createElement(_Icon.VerticalAlignTop, null))), itemType === 'right' ? notAlign() : /*#__PURE__*/_react["default"].createElement(_tooltip["default"], {
    placement: "top",
    title: '固定在列尾'
  }, /*#__PURE__*/_react["default"].createElement("i", {
    onClick: onFixedRight
  }, /*#__PURE__*/_react["default"].createElement(_Icon.VerticalAlignBottom, null)))))));
};

var _default = SettingModal;
exports["default"] = _default;