"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _reactSortablejs = require("react-sortablejs");

var _reactResizable = require("react-resizable");

require("react-resizable/css/styles.css");

var _Checkbox = _interopRequireDefault(require("./Checkbox"));

var _Spin = _interopRequireDefault(require("./Spin"));

var _SettingModal = _interopRequireWildcard(require("./SettingModal"));

var _Icon = require("./Icon");

var _this = void 0;

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } it = o[Symbol.iterator](); return it.next.bind(it); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var DragTable = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var onResize = props.onResize,
      onSort = props.onSort,
      footer = props.footer,
      pagination = props.pagination,
      _props$cacheKey = props.cacheKey,
      cacheKey = _props$cacheKey === void 0 ? '' : _props$cacheKey,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      _props$rowSelection = props.rowSelection,
      rowSelection = _props$rowSelection === void 0 ? {} : _props$rowSelection,
      _props$data = props.data,
      data = _props$data === void 0 ? [] : _props$data,
      cacheDisabled = props.cacheDisabled; // const tableHeader = useRef()

  var initState = (0, _react.useRef)({});
  var wrapRef = (0, _react.useRef)({});
  var tableContainer = (0, _react.useRef)({});
  var tableBody = (0, _react.useRef)({});
  var tableHeader = (0, _react.useRef)({});
  var tableHeaderScroller = (0, _react.useRef)({});
  var allCheckbox = (0, _react.useRef)({});
  var fixedLeft = (0, _react.useRef)([]);
  var fixedRight = (0, _react.useRef)([]);
  var notFixed = (0, _react.useRef)([]);
  var hiddenColumns = (0, _react.useRef)([]);
  var defaultColumns = (0, _react.useRef)(null);
  var rowSelect = (0, _react.useRef)();
  var settingRef = (0, _react.useRef)();
  var debounceTimer = (0, _react.useRef)();
  var resizeRef = (0, _react.useRef)({});
  var scrollHandle = (0, _react.useRef)();
  var cacheHash = (0, _react.useRef)("table_columns_" + (cacheKey + location.pathname));

  var _useState = (0, _react.useState)([]),
      columns = _useState[0],
      setColumns = _useState[1];

  var _useState2 = (0, _react.useState)([]),
      selectedRows = _useState2[0],
      setSelectedRows = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      selectedRowKeys = _useState3[0],
      setSelectedRowKeys = _useState3[1];

  var _useState4 = (0, _react.useState)(false),
      checkedAll = _useState4[0],
      setCheckedAll = _useState4[1];

  var parentSelectedRowsKeys = rowSelection && rowSelection.selectedRowKeys || [];
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      openSetting: function openSetting() {
        settingRef.current = (0, _SettingModal["default"])({
          left: fixedLeft.current,
          right: fixedRight.current,
          notFixed: notFixed.current,
          hiddenColumns: hiddenColumns.current,
          defaultColumns: defaultColumns.current,
          onSubmit: function onSubmit(nextColumns) {
            settingRef.current.destroy();
            setColumns(setColumnsAttr(nextColumns));
            setTimeout(function () {
              return setWrapScrollState(tableBody.current);
            }, 0);
          }
        });
        return settingRef.current;
      },
      getCacheHash: function getCacheHash() {
        return cacheHash.current;
      }
    };
  });
  (0, _react.useEffect)(function () {
    if (props.columns) {
      var nextColumns = props.columns.map(function (d, i) {
        d.ukey = d.dataIndex + '_' + i;
        return d;
      });
      /* 兼容 columnsState 配置 */

      if (props.columnsState) {
        var _loop = function _loop(key) {
          var val = props.columnsState[key];
          var item = nextColumns.find(function (d) {
            return d.dataIndex === key;
          });
          if (val.show === false && item) item.hidden = true;
        };

        for (var key in props.columnsState) {
          _loop(key);
        }
      }

      defaultColumns.current = [].concat(nextColumns);
      var cacheColumns = cacheDisabled ? null : localStorage.getItem(cacheHash.current);

      if (cacheColumns) {
        nextColumns = decodeCacheColumns(cacheColumns, nextColumns);
      }

      setColumns(setColumnsAttr(nextColumns));
    }

    return function () {};
  }, [props.columns]);
  (0, _react.useEffect)(function () {
    if (columns.length) {
      // 设置浮动 header 高度，隐藏滚动条
      setHeaderHeight(); // localStorage.setItem(cacheHash.current, JSON.stringify(columns))

      if (!cacheDisabled) localStorage.setItem(cacheHash.current, encodeCacheColumns([].concat(columns, hiddenColumns.current)));
    }

    return function () {};
  }, [columns]);
  (0, _react.useEffect)(function () {
    // console.log(rowSelection.selectedRowKeys)
    if (!parentSelectedRowsKeys || JSON.stringify(parentSelectedRowsKeys) === JSON.stringify(selectedRowKeys)) return;
    var nextSelectedRows = selectedRows.filter(function (d) {
      return !!parentSelectedRowsKeys.find(function (id) {
        return id === d.id;
      });
    });
    setSelectedRowKeys(parentSelectedRowsKeys);
    setSelectedRows(nextSelectedRows);
    allCheckbox.current.setIndeterminate(!!nextSelectedRows.length); // TODO 如何做全选判断?

    if (!nextSelectedRows.length) setCheckedAll(false);
    return function () {};
  }, [parentSelectedRowsKeys]);
  (0, _react.useEffect)(function () {
    rowSelection && rowSelection.onChange && rowSelection.onChange(selectedRowKeys, selectedRows);
    return function () {};
  }, [selectedRows]);
  (0, _react.useEffect)(function () {
    if (props.sticky) onScrollUpdateHeaderSticky();
    setTimeout(function () {
      if (tableBody.current) setWrapScrollState(tableBody.current);
    }, 0);
    return function () {
      if (scrollHandle.current) document.removeEventListener('scroll', scrollHandle.current);
    };
  }, []); // 0 key, 1 index, 2 fixed, 3 hidden, 4 width

  var encodeCacheColumns = function encodeCacheColumns(cols) {
    return cols.filter(function (d) {
      return !!d.ukey && d.type !== 'selection';
    }).map(function (d) {
      return d.ukey + "&" + d.index + "&" + (d.fixed || '') + "&" + (d.hidden ? 0 : 1) + "&" + d.width;
    }).join(',');
  };

  var decodeCacheColumns = function decodeCacheColumns(str, arr) {
    var cols = [];

    var _loop2 = function _loop2() {
      var d = _step.value;
      var info = d.split('&');
      var data = arr.find(function (d) {
        return d.ukey === info[0];
      });
      var item = (0, _extends2["default"])({}, data, {
        index: +info[1],
        hidden: info[3] === '0' ? true : false
      });

      if (info[4]) {
        item.width = +info[4];
      }

      if (info[2]) {
        item.fixed = info[2];
      } else {
        delete item.fixed;
      }

      cols.push(item);
    };

    for (var _iterator = _createForOfIteratorHelperLoose(str.split(',')), _step; !(_step = _iterator()).done;) {
      _loop2();
    }

    return cols;
  }; // 根据配置，设置固定列定位值


  var setColumnsAttr = function setColumnsAttr(columns) {
    // console.log(columns)
    var left = fixedLeft.current = [];
    var right = fixedRight.current = [];
    var normal = notFixed.current = [];
    columns = columns.filter(function (d) {
      return d.type !== 'selection';
    });
    hiddenColumns.current = [];
    var i = 0;

    for (var _iterator2 = _createForOfIteratorHelperLoose(columns), _step2; !(_step2 = _iterator2()).done;) {
      var d = _step2.value;
      d.style = d.cls = null;

      if (typeof d.index === 'undefined') {
        d.index = i;
        i++;
      }

      if (d.hidden) {
        hiddenColumns.current.push(d);
        continue;
      }

      if (d.fixed === 'left') {
        left.push(d);
      } else if (d.fixed === 'right') {
        right.push(d);
      } else {
        normal.push(d);
      }
    }

    setRowSelection();
    setWrapFixedState();
    left = setLeftStyle();
    right = setRightStyle();
    return mergeColumns({
      left: left,
      right: right,
      normal: normal
    });
  };

  var setRowSelection = function setRowSelection() {
    if (props.rowSelection) {
      var selectedRow = rowSelect.current = {
        type: 'selection',
        // 这个地方可以不用写 key，type 就相当于 key
        width: 55
      };

      if (fixedLeft.current.length) {
        fixedLeft.current.unshift(selectedRow);
      } else {
        notFixed.current.unshift(selectedRow);
      }
    }
  };

  var setWrapFixedState = function setWrapFixedState() {
    var wrapCls = Array.from(wrapRef.current.classList).filter(function (d) {
      return !/^shj-table-has-fix-left$|^shj-table-has-fix-right$/g.test(d);
    });
    if (fixedLeft.current.length) wrapCls.push('shj-table-has-fix-left');
    if (fixedRight.current.length) wrapCls.push('shj-table-has-fix-right');
    wrapRef.current.className = wrapCls.join(' ');
  };

  var setLeftStyle = function setLeftStyle() {
    var list = fixedLeft.current;
    var offset = 0;

    for (var i = 0; i < list.length; i++) {
      list[i].style = {
        left: offset + 'px'
      };
      var cls = 'drag-col-fixed-left';

      if (i === list.length - 1) {
        cls = cls + " " + cls + "-last";
      }

      list[i].cls = cls;
      offset += list[i].width;
    }

    return list;
  };

  var setRightStyle = function setRightStyle() {
    var list = fixedRight.current;
    var offset = 0;

    for (var i = list.length - 1; i >= 0; i--) {
      list[i].style = {
        right: offset + 'px'
      };
      var cls = 'drag-col-fixed-right';

      if (i === 0) {
        cls = cls + " " + cls + "-last";
      }

      list[i].cls = cls;
      offset += list[i].width;
    }

    return list;
  };

  var mergeColumns = function mergeColumns(_temp) {
    var _ref = _temp === void 0 ? {} : _temp,
        _ref$left = _ref.left,
        left = _ref$left === void 0 ? fixedLeft.current : _ref$left,
        _ref$right = _ref.right,
        right = _ref$right === void 0 ? fixedRight.current : _ref$right,
        _ref$normal = _ref.normal,
        normal = _ref$normal === void 0 ? notFixed.current : _ref$normal;

    return [].concat(left, normal, right);
  };

  var setHeaderHeight = function setHeaderHeight() {
    var rect = tableHeader.current.querySelector('.shj-header-table').getBoundingClientRect();

    if (rect.height) {
      tableHeader.current.style.height = rect.height + 'px';
      initState.current.isInitHeaderHeight = true;
    }
  };

  var onScrollUpdateHeaderSticky = function onScrollUpdateHeaderSticky() {
    var header = tableHeader.current;
    var scroller = tableHeader.current.firstElementChild;
    var body = tableBody.current;
    var table = body.querySelector('.shj-body-table');
    var scrollBar = header.querySelector('.header-scroll-bar');

    scrollHandle.current = function () {
      var bodyRect = body.getBoundingClientRect();
      var tableRect = table.getBoundingClientRect(); // console.log(tableRect.top, header.offsetHeight)

      if (tableRect.top && header.offsetHeight && tableRect.top - header.offsetHeight <= 0) {
        if (!initState.current.isInitHeaderHeight) setHeaderHeight();
        scrollBar.style.height = '30px';
        header.style.position = 'fixed';
        header.style.overflow = 'hidden';
        if (bodyRect.width) header.style.width = bodyRect.width + 'px'; // scroller.style.overflow = 'auto'

        scroller.style.overflow = 'hidden';
        body.style.paddingTop = header.offsetHeight + 'px'; // 防止头部超出表格范围

        if (Math.abs(tableRect.top) + header.offsetHeight > tableRect.height) {
          header.style.top = tableRect.height - (Math.abs(tableRect.top) + header.offsetHeight) + 'px';
        } else {
          header.style.top = header.style.bottom = '';
        }

        if (scroller && tableContainer.current) {
          if (scroller.scrollLeft !== tableContainer.current.scrollLeft) {
            scroller.scrollLeft = tableContainer.current.scrollLeft;
          }
        }
      } else {
        scrollBar.style.height = body.style.paddingTop = scroller.style.overflow = header.style.position = header.style.overflow = header.style.width = '';
      }
    };

    scrollHandle.current();
    document.addEventListener('scroll', scrollHandle.current);
  };

  var onBodyScroll = function onBodyScroll(ev) {
    var setScrollLeft = function setScrollLeft(target) {
      if (target === tableContainer.current && ev.target.scrollLeft !== tableHeaderScroller.current.scrollLeft) {
        tableHeaderScroller.current.scrollLeft = target.scrollLeft;
      }
    };

    setScrollLeft(ev.target); // console.log(ev.target)
    // console.log(tableHeader.current.scrollLeft, ev.target.scrollLeft)

    setWrapScrollState(tableBody.current, ev.target);
  };

  var setWrapScrollState = function setWrapScrollState(el, scroller) {
    if (scroller === void 0) {
      scroller = tableContainer.current;
    }

    var childWidth = el.firstElementChild.offsetWidth;
    var max = Math.abs(scroller.offsetWidth - childWidth);
    var cls = Array.from(wrapRef.current.classList).filter(function (d) {
      return !/^shj-table-ping-left$|^shj-table-ping-right$/g.test(d);
    });

    if (max) {
      if (scroller.scrollLeft > 0 && scroller.scrollLeft < max) {
        cls.push('shj-table-ping-left');
        cls.push('shj-table-ping-right');
      } else if (scroller.scrollLeft > 0) {
        cls.push('shj-table-ping-left');
      } else {
        cls.push('shj-table-ping-right');
      }
    }

    wrapRef.current.className = cls.join(' ');
  };

  var _onResizeStart = function _onResizeStart(d, i, e, _temp2) {
    var _ref2 = _temp2 === void 0 ? {} : _temp2,
        node = _ref2.node;

    resizeRef.current.startX = e.clientX;
  };

  var _onResize = function _onResize(d, i, e, _temp3) {
    var _ref3 = _temp3 === void 0 ? {} : _temp3,
        node = _ref3.node;

    e.stopPropagation();
    e.preventDefault();
    var x = e.clientX - resizeRef.current.startX;
    node.style.right = -x + 'px';
    node.parentNode.style.zIndex = 200;
    node.style.opacity = 1;
    resizeRef.current.x = x;
  };

  var _onResizeStop = function _onResizeStop(d, i, e, _temp4) {
    var _ref4 = _temp4 === void 0 ? {} : _temp4,
        size = _ref4.size,
        node = _ref4.node;

    e.stopPropagation();
    e.preventDefault();
    var width = columns[i].width + resizeRef.current.x < 50 ? 50 : columns[i].width + resizeRef.current.x;
    columns[i].width = width;

    if (d.fixed === 'left') {
      setLeftStyle();
    } else if (d.fixed === 'right') {
      setRightStyle();
    }

    setColumns(mergeColumns());
    clearInterval(debounceTimer.current);
    debounceTimer.current = setTimeout(function () {
      setWrapScrollState(tableBody.current);
    }, 200);
    node.style.right = node.style.opacity = node.parentNode.style.zIndex = '';
    onResize && onResize(i, width);
  };

  var _allowDrop = function _allowDrop(ev) {
    ev.preventDefault();
  };

  var _drag = function _drag(ev) {
    // console.log(ev.target.dataset.index)
    ev.dataTransfer.setData("dragIndex", ev.target.dataset.index);
  };

  var _onDrop = function _onDrop(ev) {
    var prevIndex = ev.dataTransfer.getData("dragIndex");
    var nextIndex = ev.target.dataset.index;

    _onSort(prevIndex, nextIndex);

    onSort && onSort(prevIndex, nextIndex);
    ev.preventDefault();
  };

  var _onSort = function _onSort(prevIndex, nextIndex) {
    if (prevIndex === nextIndex) return;
    var nextColumns = [].concat(columns, hiddenColumns.current);
    var tempIndex = nextColumns[prevIndex].index;
    nextColumns[prevIndex].index = nextColumns[nextIndex].index;
    nextColumns[nextIndex].index = tempIndex;
    var temp = nextColumns[nextIndex];
    nextColumns[nextIndex] = nextColumns[prevIndex];
    nextColumns[prevIndex] = temp;

    if (prevIndex < nextIndex) {
      if (nextColumns[nextIndex].fixed === 'left') {
        var prevFixed = nextColumns[prevIndex].fixed;
        nextColumns[prevIndex].fixed = nextColumns[nextIndex].fixed;
        nextColumns[nextIndex].fixed = prevFixed;
      } else {
        var _prevFixed = nextColumns[nextIndex].fixed;
        nextColumns[nextIndex].fixed = nextColumns[prevIndex].fixed;
        nextColumns[prevIndex].fixed = _prevFixed;
      }
    } else {
      if (nextColumns[prevIndex].fixed === 'left') {
        var _prevFixed2 = nextColumns[nextIndex].fixed;
        nextColumns[nextIndex].fixed = nextColumns[prevIndex].fixed;
        nextColumns[prevIndex].fixed = _prevFixed2;
      } else {
        var _prevFixed3 = nextColumns[prevIndex].fixed;
        nextColumns[prevIndex].fixed = nextColumns[nextIndex].fixed;
        nextColumns[nextIndex].fixed = _prevFixed3;
      }
    }

    setColumns(setColumnsAttr(nextColumns));
  };

  var selectAll = function selectAll() {
    var nextChecked = !checkedAll;

    if (checkedAll) {
      setCheckedAll(false);
      setSelectedRows([]);
      setSelectedRowKeys([]);
    } else {
      setCheckedAll(true);

      var _nextSelected = [].concat(selectedRows);

      var nextSelectedKeys = [].concat(selectedRowKeys);

      var _loop3 = function _loop3() {
        var item = _step3.value;

        if (_nextSelected.findIndex(function (d) {
          return d.id === item.id;
        }) === -1) {
          _nextSelected.push(item);

          nextSelectedKeys.push("" + item.id);
        }
      };

      for (var _iterator3 = _createForOfIteratorHelperLoose(props.data), _step3; !(_step3 = _iterator3()).done;) {
        _loop3();
      }

      setSelectedRows(_nextSelected);
      setSelectedRowKeys(nextSelectedKeys);
    }

    rowSelection && rowSelection.onSelectAll && rowSelection.onSelectAll(nextChecked, nextSelected);
  };

  var toggleSelect = (0, _react.useCallback)(function (row, index, checked) {
    if (checked) {
      selectedRows.push(row);
      selectedRowKeys.push("" + row.id);
    } else {
      selectedRows.splice(selectedRows.findIndex(function (d) {
        return d.id === row.id;
      }), 1);
      selectedRowKeys.splice(selectedRowKeys.findIndex(function (d) {
        return d === "" + row.id;
      }), 1);
      setCheckedAll(false);
    }

    setSelectedRows([].concat(selectedRows));
    setSelectedRowKeys([].concat(selectedRowKeys));
    allCheckbox.current.setIndeterminate(!!selectedRows.length);
    rowSelection && rowSelection.onSelect && rowSelection.onSelect(row, checked, selectedRows, e);
  }, [rowSelection, allCheckbox, selectedRows, selectedRowKeys]);

  var isSelectedAll = function isSelectedAll() {
    // if (selectedRows.length < data.length) return false
    if (checkedAll) return checkedAll;
    if (typeof props.total !== 'undefined' && props.total !== selectedRows.length) return false;
    if (!props.data) return false;
    var res = props.data.length && props.data.every(function (item) {
      return selectedRows.findIndex(function (d) {
        return d.id === item.id;
      }) !== -1;
    });
    return res;
  };

  var formateStatus = function formateStatus(row) {
    return !!selectedRows.find(function (d) {
      return d.id === row.id;
    });
  };

  var renderTh = function renderTh(d, i) {
    return /*#__PURE__*/_react["default"].createElement("th", {
      key: d.ukey || d.key || d.type || 'th_' + i,
      className: "drag-move " + (d.cls || ''),
      style: d.style || {}
    }, d.type === 'selection' ? /*#__PURE__*/_react["default"].createElement("div", {
      className: "col-checkbox-wrap"
    }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
      ref: allCheckbox,
      checked: isSelectedAll(),
      onChange: selectAll
    })) : null, !d.type ? /*#__PURE__*/_react["default"].createElement("div", {
      className: "th-cell",
      "data-key": d.key,
      "data-index": i,
      draggable: true,
      onDragOver: _allowDrop
    }, d.title) : null);
  }; // console.log('render')


  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-drag-table " + (props.className || ''),
    ref: wrapRef
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-drag-table__container",
    onScroll: onBodyScroll,
    ref: tableContainer
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-drag-table__header ",
    ref: tableHeader,
    onDragStart: _drag,
    onDrop: _onDrop
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: 'header-scroll-wrap',
    ref: tableHeaderScroller
  }, /*#__PURE__*/_react["default"].createElement("table", {
    className: "shj-header-table"
  }, /*#__PURE__*/_react["default"].createElement("colgroup", null, columns.map(function (d, i) {
    return /*#__PURE__*/_react["default"].createElement("col", {
      key: i,
      style: {
        width: isNaN(d.width) ? d.width : d.width + 'px' || '',
        minWidth: isNaN(d.width) ? d.width : d.width + 'px' || ''
      }
    });
  })), /*#__PURE__*/_react["default"].createElement("thead", null, /*#__PURE__*/_react["default"].createElement("tr", null, columns.map(function (d, i) {
    return !d.width || d.type === 'selection' ? renderTh(d, i) : /*#__PURE__*/_react["default"].createElement(_reactResizable.Resizable, {
      key: d.ukey || d.key || d.type || 'rth_' + i,
      width: d.width,
      height: 0,
      handle: /*#__PURE__*/_react["default"].createElement("div", {
        className: "resize-handle-rect"
      }),
      onResize: _onResize.bind(_this, d, i),
      onResizeStart: _onResizeStart.bind(_this, d, i),
      onResizeStop: _onResizeStop.bind(_this, d, i)
    }, renderTh(d, i));
  })))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "header-scroll-bar"
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-drag-table__scroller"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-drag-table__body",
    ref: tableBody
  }, /*#__PURE__*/_react["default"].createElement("table", {
    className: "shj-body-table"
  }, /*#__PURE__*/_react["default"].createElement("colgroup", null, columns.map(function (d, i) {
    return /*#__PURE__*/_react["default"].createElement("col", {
      key: i,
      style: {
        width: isNaN(d.width) ? d.width : d.width + 'px' || '',
        minWidth: isNaN(d.width) ? d.width : d.width + 'px' || ''
      }
    });
  })), /*#__PURE__*/_react["default"].createElement("tbody", null, data.map(function (row, i) {
    var rowChecked = formateStatus(row);
    return /*#__PURE__*/_react["default"].createElement("tr", {
      key: i
    }, columns.map(function (d, j) {
      return /*#__PURE__*/_react["default"].createElement("td", {
        key: d.ukey || data.dataIndex || data.type || j,
        className: d.cls || '',
        style: d.style || {}
      }, d.type === 'selection' ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "col-checkbox-wrap"
      }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
        checked: rowChecked,
        onChange: toggleSelect.bind(_this, row, i)
      })) : null, !d.type ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "td-cell"
      }, d.render ? d.render(row[d.dataIndex], row, j) : row[d.dataIndex]) : null);
    }));
  })))), !data.length ? /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-table-empty"
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Empty, null), /*#__PURE__*/_react["default"].createElement("div", {
    className: "shj-table-empty-text"
  }, "\u6682\u65E0\u6570\u636E")) : null), loading ? /*#__PURE__*/_react["default"].createElement(_Spin["default"], null) : null);
});
DragTable.propTypes = {};
DragTable.defaultProps = {};
var _default = DragTable;
exports["default"] = _default;